bool init_ports(void);	
bool init_timers(void);	
bool init_uart(void);
bool init_ADC(void);

bool init_ports(void)
{	
	//PORT A
	//PA0 IR_IN
	//PA1 LED
	//PA2 IN3
	//PA3 IN4
	//PA4 SCK
	//PA5 MISO
	//PA6 MOSI
	//PA7 IR_OUT
	DDRA |=  0b01000101;
	DDRA &= ~0b10111010;
	
	//PORTB
	//PB0 IN1
	//PB1 IN2
	//PB2 OC0A
	DDRB |=  0x04;
	DDRB &= ~0x03;
	
	return true;
}

bool init_timers(void)
{
//Run main loop on interrupts
/*
	//timer 0 Tick Generation
	//Normal operation, Prescaling 1024
	//Interrupt on overflow every 16us
	TCCR0A = 0b00000000; 
	TCCR0B = 0b00000101;
	TIMSK0 |= 0x01;

*/
	// Servo output
	// Clock source: System Clock. Clock value: 8MHz
	// Mode: Fast PWM: top=OCR0A. WGM 101
	// OC0A output: Non-Inv. OC0B output: Non-Inv
	TCCR0A = 0b10100011;	//Clear on compare match, set at bottom
	TCCR0B = 0b00000101;	//Clock prescaling 1024 (TCNT0 = 256-156 = 50z overflow)
	TIMSK0 |= 0x01;			//Timer overflow interrupt enable
	OCR0A  = 100;			//SERVO_R 108 - 115
	OCR0B  = 100; 			//SERVO_L 
	TCNT0  = 100;		    //Generate 50Hz PWM Signal 

	return true;
}

bool init_UART(void)
{
/*
	DDRD  &= ~0x04; // RXD1 - PD2
	PORTD |=  0x04; // Pull-up

	//UART1 XBEE
	UCSR1A &= ~0b00000011;//Clear all flags. No multiprocessor communication. Not double speed.
	UBRR1H = 0; 		 //Baud rate 38400bps @ 8Mhz. 
	UBRR1L = 12;        //Baud rate 38400bps @ 8Mhz. 
	UCSR1B = 0b11011000; //Enable int. on rx complete and on UDR empty. TX logic, 8-bit transmission. 
	UCSR1C = 0b00000110; //Asynchronous, parity bit check disabled, 1 stop bit, 8-bit transmission.
*/
	return true;
}

bool init_ADC(void)
{
/*
	//setup adc single conversion-mode, AVCC reference, left adjust result, start on channel 0
	ADMUX   =  0b01100000; //((0<<REFS1) | (1<<REFS0) | (1<<ADLAR)); 
	ADCSRB &= ~0b00001000;
	ADCSRA  =  0b10001010; // Prescale 4, enable interrupt
*/	
	return true;
}

